package nc.bs.yp.impl;

import java.io.IOException;
import java.io.PrintWriter;
import java.io.StringWriter;
import java.util.ArrayList;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import nc.bs.dao.BaseDAO;
import nc.bs.dao.DAOException;
import nc.bs.framework.adaptor.IHttpServletAdaptor;
import nc.bs.framework.common.InvocationInfoProxy;
import nc.bs.framework.common.NCLocator;
import nc.bs.framework.server.ISecurityTokenCallback;
import nc.bs.pub.pf.PfUtilTools;
import nc.bs.servlet.service.BaseServlet;
import nc.itf.mmsfc.operationrep.IOprepMaintain;
import nc.jdbc.framework.processor.ColumnProcessor;
import nc.log.NcLog;
import nc.md.persist.framework.IMDPersistenceQueryService;
import nc.mm.mmsfc.task.BatchTaskVO;
import nc.vo.mmpac.pmo.pac0002.entity.PMOAggVO;
import nc.vo.mmsfc.operationrep.entity.AggOprepVO;
import nc.vo.mmsfc.operationrep.entity.OprepItemVO;
import nc.vo.mmsfc.operationrep.entity.OprepVO;
import nc.vo.pub.BusinessException;
import nc.vo.pub.VOStatus;
import net.sf.json.JSONArray;
import net.sf.json.JSONObject;


/**
 * 깤
 * @author LP
 *
 */
@SuppressWarnings("restriction")
public class OprepAddImpl extends BaseServlet implements IHttpServletAdaptor {
	
	private static final String TURE = "0";
	private static final String FALSE = "1";
	private IMDPersistenceQueryService qryService = NCLocator.getInstance().lookup(IMDPersistenceQueryService.class);
	private BaseDAO dao = new BaseDAO();
	private JSONObject p_data = null;
	private String vbillcodeOprep = "";

	@Override
	public void doAction(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
		
		NCLocator.getInstance().lookup(ISecurityTokenCallback.class).token("NCSystem".getBytes(),"pfxx".getBytes());
        InvocationInfoProxy.getInstance().setUserDataSource("syptest210103");
		
        String vbillcode = "";
        String errorMessgae = "";
        JSONObject logObject = new JSONObject();
        logObject.accumulate("InterName","깤");
		String json = buildJson(req, resp, this.getClass().getName());
		PrintWriter out = resp.getWriter();

		try {
			
			p_data = JSONObject.fromObject(json);//ȡ
			
			logObject.accumulate("InputData", p_data);
			
			vbillcode = p_data.getString("vbillcode");//ȡ
			
			checkJson();//ǿж
			
			InvocationInfoProxy.getInstance().setGroupId(SqlexecuteQuery("pk_group", "org_group", "code", p_data.getString("group")));
			InvocationInfoProxy.getInstance().setUserId(SqlexecuteQuery("cuserid", "sm_user", "user_code", p_data.getString("creator")));
			
			AggOprepVO aggOprepVO = getAggOprepVO(vbillcode);
			
			addAggOprepVO(aggOprepVO);
			
			out.print(formatRSJsonData(TURE, vbillcodeOprep, "ɹ"));
			logObject.accumulate("OutData", formatRSJsonData(TURE, vbillcodeOprep, "ɹ").toString());
			
		} catch (Exception e) {
			
			String error = e.getMessage()==null?e.toString():e.getMessage().toString();
			out.print(formatRSJsonData(FALSE, vbillcodeOprep, error));
			logObject.accumulate("OutData",formatRSJsonData(FALSE, vbillcodeOprep, error).toString());
			errorMessgae = StackTrace(e);
			
		}finally {
			NcLog.info(logObject.toString()+"\r"+errorMessgae);
			out.flush();
			out.close();
		}
		
	}
	
	/*
	 *addAggOprepVO()
	 */
	private void addAggOprepVO(AggOprepVO aggOprepVO) throws BusinessException {
		
		AggOprepVO newAggOprepVO = new AggOprepVO();
		
		OprepVO parentVO = aggOprepVO.getParentVO();
		OprepItemVO[] childrenVO = aggOprepVO.getChildrenVO();
		
		//--------------------------ͷװOprepVO-------------------------
		
		parentVO.setStatus(VOStatus.NEW);
		
		newAggOprepVO.setParentVO(parentVO);
		
		//--------------------------װOprepVO-------------------------
		
		JSONArray bodyArray = p_data.getJSONArray("body");
		
		for (OprepItemVO oprepItemVO : childrenVO) {
			
			for (Object Object : bodyArray) {
				
				JSONObject bodyObject = JSONObject.fromObject(Object);
				
				String cmaterialCode = bodyObject.getString("cmaterialvid");
				
				String cmaterialPk = SqlexecuteQuery("pk_material", "bd_material", "code", cmaterialCode);
				
				if (cmaterialPk.equals(oprepItemVO.getCbmaterialvid())) {
					
					oprepItemVO.setStatus(VOStatus.NEW);
					
				}
			}
		}
		
		newAggOprepVO.setChildrenVO(childrenVO);
		
		//--------------------------OperepVO----------------------------
		
		BatchTaskVO<AggOprepVO> insertOprep = NCLocator.getInstance().lookup(IOprepMaintain.class).insertOprep(new AggOprepVO[] {newAggOprepVO});
		
		vbillcodeOprep = insertOprep.getBills()[0].getParentVO().getVbillcode();
		
	}
	
	/*
	 * ת
	 */
	private AggOprepVO getAggOprepVO(String vbillcode) throws Exception {
		
		PMOAggVO pmoAggVO = getPmoVO(vbillcode);
		
		AggOprepVO oprepVO = (AggOprepVO) PfUtilTools.runChangeData("55E8", "55D2", pmoAggVO);
		
		return oprepVO;
	}
	
	/*
	 * ǿж
	 */
	private void checkJson() throws Exception {
		
		StringBuffer mags = new StringBuffer();
		Boolean empty = true;
		
		String vbillcode = "vbillcode";//
		String group = "group";//ű
		String creator = "creator";//
		
		String body = "body";//
 
		String[] HeadKey = {vbillcode,group,creator};
		
		for (String as : HeadKey) {

			if (p_data.getString(as).isEmpty()) {
				empty = false;
				mags.append("'" + as + "'");
			}
		}
		
		if (p_data.getJSONArray(body)==null) {
			empty = false;
			mags.append(" 'body'岻ڣ ");
		}
		
//----------------------------------------------------------
		
		JSONArray oprepObjectBs = p_data.getJSONArray("body");
		
		if (oprepObjectBs == null || oprepObjectBs.size() == 0) {
			throw new Exception("ݲΪգ");
		}
		
		String cmaterialvid = "cmaterialvid";//ϱ
		
		for(int i = 0; i < oprepObjectBs.size(); i++) {
			
			JSONObject oprepJsonObjectB = oprepObjectBs.getJSONObject(i);
			String[] BodyKey = {cmaterialvid};
			int num = i+1;
			
			mags.append(""+num+"壺{");
			for (String as : BodyKey) {

				if (oprepJsonObjectB.getString(as).isEmpty()) {
					empty = false;
					mags.append("'" + as + "' ");
				}
			}
			mags.append("}");
		}
		
		if (!empty) {
			throw new Exception("ֶβΪգ"+mags);
		}
	}
	
	/*
	 * ȡAggVO
	 */
	@SuppressWarnings("unchecked")
	private PMOAggVO getPmoVO(String vbillcode) throws Exception {
		
		ArrayList<PMOAggVO> PmoAggVOs = (ArrayList<PMOAggVO>) 
				qryService.queryBillOfVOByCond(PMOAggVO.class,"vbillcode = '"+vbillcode+"'",true,false);
		
		if (PmoAggVOs == null || PmoAggVOs.size() == 0) {
			throw new Exception("ݵݺ'"+vbillcode+"'δҵ飡");
		}else {
			PMOAggVO pmoAggVO = (PMOAggVO) PmoAggVOs.get(0).clone();
			return pmoAggVO;
		}
	}

	/*
	 * 쳣Ϣϸ
	 */
	private String StackTrace(Exception e) {
	    StringWriter sw = new StringWriter();
	    PrintWriter pw = new PrintWriter(sw);
	    e.printStackTrace(pw);
	    return sw.toString();
	}
	
	/*
	 * ݿѯ
	 */
	private String SqlexecuteQuery(String out,String table,String key,String value) throws DAOException {
		
		String sql = "select "+out+" from "+table+" where "+key+" = '"+value+"' and nvl(dr,0)=0";
		
		Object object = dao.executeQuery(sql, new ColumnProcessor());
		
		if (object==null) {
			throw new DAOException("δѯݣ"+value+"Ƿȷ");
		}
		
		return object.toString();
		
	}
}
